/* it's a converter from HDF-EOS to netCDF, so it needs to know about
   both of them */
#include "HE5_HdfEosDef.h"
#include "netcdf.h"
/* and stdio, what the heck */
#include <stdio.h>

/* Trace code support.  TRACE((stderr, "format string", args...)) */
#ifdef TRACE_OUTPUT
#define TRACE(x) fprintf x
#else
#define TRACE(x)
#endif

/* turn this on to enable malloc/free tracing */
#if TRACE_MALLOC
#define malloc MYmalloc
#define calloc MYcalloc
#define free MYfree
#endif

/* support for simple and stupid error handling -
   if a call returns a bad status,
   just print the status, the statement that errored, and exit.  We'll
   have to do better in the future, of course...
*/

/* ANSI pre-processor macro substitution, gotta love it... */

#define SS(x) spit_status(x, #x "")

/* insures that nc_redef and nc_enddef use my wrapper functions instead
   of the standard one
*/
#define nc_redef  MYnc_redef
#define nc_enddef MYnc_enddef

/* Dimension map stuff.  I am assuming that dimensions are global across
   all (point/swath/grid) objects in one file.  This does not necessarily
   have to be true, but it would be insane to create a file otherwise.

   I spoke too soon.  It makes perfect sense for XDim/YDim to vary inside
   a grid file, because the names "XDim" and "YDim" are shared by
   all grids.
*/

/* dimension maps are linked lists of dment entries */
struct dment {
  struct dment *next;
  char *Hname;
  char *Nname;
  int size;
  int id;
};


/* And declarations for stuff in other files (like support.c) */

#ifdef TRACE_MALLOC
void *MYmalloc(size_t size);
char *MYcalloc(size_t nmemb, size_t size);
void MYfree(void *ptr);
#endif
int MYnc_redef(int ncid);
int MYnc_enddef(int ncid);

void spit_status(int stat, char *call);
char *newstring(int len);
char *strclone(char *in);
void end_name(char *namebuf);
char *next_name (char *namebuf);
struct dment *find_dimension (struct dment *map, char *name);
struct dment *add_dimension(struct dment **map, char *Hname, char *Nname, int size, int id);
void fix_nc_varname(char *vn);

/* the usual predeclaration of functions */

void convert_point(char* , char* , int);
void convert_swath(char* , char* , int);
void convert_grid(char* , char* , int);

